Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       aisa29.bas
'
'       AISA-M29 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

Global Const AISA29_SLOT_AUTO = &HFFFF
Global Const AISA29_MAX_SLOTS = 16

' G[R[h
Global Const AISA29_SUCCESS = 0                      ' ُȂiIj
Global Const AISA29_ERR_SYSTEM = 1                   ' GetLastError() R[Ă
Global Const AISA29_ERR_NO_DEVICE = 2                ' gp\ȃfoCX܂
Global Const AISA29_ERR_IN_USE = 3                   ' w̃foCX͎gpł
Global Const AISA29_ERR_INVALID_SLOT = 4             ' Ș_Xbgł
Global Const AISA29_ERR_RESOURCE = 5                 ' \[XG[
Global Const AISA29_ERR_INVALID_PORT = 6             ' sȃ|[gv
Global Const AISA29_ERR_INVALID_ARGUMENT = 7         ' sȈv܂
Global Const AISA29_ERR_INVALID_CREQ_PORT = 50       ' s CREQ |[gv
Global Const AISA29_ERR_INVALID_COMMAND = 51         ' sȃR}hv
Global Const AISA29_ERR_INVALID_MODE = 52            ' sȃ[hw肵

' C-REQ ɏރ_~[f[^
Global Const AISA29_CREQ_DATA = &H0

' R}h|[gւ̃[hݒ莞̃_~[f[^
Global Const AISA29_COMMAND_SET_DATA = &H0

' |[g
Global Const AISA29_MODE_WRITE_PORT = &H4
Global Const AISA29_STATUS_READ_PORT = &H0
Global Const AISA29_COMMAND_WRITE_PORT = &H0
Global Const AISA29_CREQ_1_WRITE_PORT = &H6
Global Const AISA29_CREQ_2_WRITE_PORT = &H7
Global Const AISA29_DATA_1_PORT = &H1
Global Const AISA29_DATA_2_PORT = &H2
Global Const AISA29_DATA_3_PORT = &H3

' C-REQ `l
Global Const AISA29_CREQ_1 = &H1
Global Const AISA29_CREQ_2 = &H2

' [h
Global Const AISA29_CH2_COUNTER_CLEAR_MODE = &H80
Global Const AISA29_CH1_COUNTER_CLEAR_MODE = &H40
Global Const AISA29_CH1_CH2_COMPARATE_MODE = &H20
Global Const AISA29_CH2_COMPARATE_MODE = &H10
Global Const AISA29_CH1_COMPARATE_MODE = &H8
Global Const AISA29_INTERRUPT_CONTROL_3 = &H4              ' T|[g
Global Const AISA29_INTERRUPT_CONTROL_2 = &H2              ' T|[g
Global Const AISA29_INTERRUPT_CONTROL_1 = &H1              ' T|[g

' ݃R}h
Global Const AISA29_CH1_COUNTER_WRITE = &H0
Global Const AISA29_CH1_COMPARATOR_WRITE = &H1
Global Const AISA29_CH2_COUNTER_WRITE = &H2
Global Const AISA29_CH2_COMPARATOR_WRITE = &H3
Global Const AISA29_CH1_PRE_SCALER_WRITE = &H8
Global Const AISA29_CH2_PRE_SCALER_WRITE = &H9
Global Const AISA29_SYNCRONOUS_WRITE = &HC
Global Const AISA29_LEVEL_CLEAR_MODE_SET = &HE
Global Const AISA29_EDGE_CLEAR_MODE_SET = &HF
Global Const AISA29_CH1_PULSE_MODE_SET = &H10
Global Const AISA29_CH1_2_PHASE_X1_MODE_SET = &H11
Global Const AISA29_CH1_2_PHASE_X2_MODE_SET = &H12
Global Const AISA29_CH1_2_PHASE_X4_MODE_SET = &H13
Global Const AISA29_CH1_COUNT_ENABLE_SET = &H14
Global Const AISA29_CH1_COUNT_DISABLE_SET = &H15
Global Const AISA29_SEPARATE_MODE_SET = &H16
Global Const AISA29_CASCADE_MODE_SET = &H17
Global Const AISA29_CH2_PULSE_MODE_SET = &H18
Global Const AISA29_CH2_2_PHASE_X1_MOED_SET = &H19
Global Const AISA29_CH2_2_PHASE_X2_MOED_SET = &H1A
Global Const AISA29_CH2_2_PHASE_X4_MOED_SET = &H1B
Global Const AISA29_CH2_COUNT_ENABLE_SET = &H1C
Global Const AISA29_CH2_COUNT_DISABLE_SET = &H1D

' ǂݍ݃R}h
Global Const AISA29_CH1_COUNTER_READ = &H4
Global Const AISA29_CH1_COMPARATOR_READ = &H5
Global Const AISA29_CH2_COUNTER_READ = &H6
Global Const AISA29_CH2_COMPARATOR_READ = &H7
Global Const AISA29_CH1_PRE_SCALER_READ = &HA
Global Const AISA29_CH2_PRE_SCALER_READ = &HB
Global Const AISA29_SYNCRONOUS_READ = &HD

' \[X\
Global Const AISA29_MAX_MEM = 9
Global Const AISA29_MAX_IO = 20
Global Const AISA29_MAX_IRQ = 7
Global Const AISA29_MAX_DMA = 7

Type AISA29RESOURCE
    dwNumMemWindows As Long                         ' Not used
    dwMemBase(1 To AISA29_MAX_MEM) As Long          ' Not used
    dwMemLength(1 To AISA29_MAX_MEM) As Long        ' Not used
    dwMemAttrib(1 To AISA29_MAX_MEM) As Long        ' Not used
    dwNumIOPorts As Long                            ' Num IO ports
    dwIOPortBase(1 To AISA29_MAX_IO) As Long        ' I/O port base
    dwIOPortLength(1 To AISA29_MAX_IO) As Long      ' I/O port length
    dwNumIRQs As Long                               ' Num IRQ info
    dwIRQRegisters(1 To AISA29_MAX_IRQ) As Long     ' IRQ list
    dwIRQAttrib(1 To AISA29_MAX_IRQ) As Long        ' IRQ Attrib list
    dwNumDMAs As Long                               ' Not used
    dwDMALst(1 To AISA29_MAX_DMA) As Long           ' Not used
    dwDMAAttrib(1 To AISA29_MAX_DMA) As Long        ' Not used
    dwReserved1(1 To 3) As Long                     ' Not used
End Type

Declare Function Aisa29GetVersion Lib "aisa29" (ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Long
Declare Function Aisa29Create Lib "aisa29" (ByRef pwLogSlot As Integer) As Long
Declare Function Aisa29Close Lib "aisa29" (ByVal wLogSlot As Integer) As Long
Declare Function Aisa29GetResource Lib "aisa29" (ByVal wLogSlot As Integer, pres As AISA29RESOURCE) As Long
Declare Function Aisa29ModeSet Lib "aisa29" (ByVal wLogSlot As Integer, ByVal bMode As Byte) As Long
Declare Function Aisa29CreqWrite Lib "aisa29" (ByVal wLogSlot As Integer, ByVal wCreq As Integer) As Long
Declare Function Aisa29GetStatus Lib "aisa29" (ByVal wLogSlot As Integer, ByRef pbStatus As Byte) As Long
Declare Function Aisa29DataWrite Lib "aisa29" (ByVal wLogSlot As Integer, ByVal bCmd As Byte, ByVal dwData As Long) As Long
Declare Function Aisa29DataRead Lib "aisa29" (ByVal wLogSlot As Integer, ByVal bCmd As Byte, ByRef pdwData As Long) As Long
Declare Function Aisa29CascadeWrite Lib "aisa29" (ByVal wLogSlot As Integer, ByVal dwCH1Data As Long, ByVal dwCH2Data As Long) As Long
Declare Function Aisa29CascadeRead Lib "aisa29" (ByVal wLogSlot As Integer, ByRef pdwCh1Data As Long, ByRef pdwCh2Data As Long) As Long
Declare Function Aisa29GetLastError Lib "aisa29" (ByVal wLogSlot As Integer) As Long
